﻿<%@ Page Language="C#" MasterPageFile="~/Site.Master" Title="Kanban" AutoEventWireup="true" CodeBehind="KanbanFeatures.aspx.cs" Inherits="SyncfusionASPNETApplication21.KanbanFeatures" %>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
    <div>
        <div id="ControlRegion">
            <asp:UpdatePanel ID="UpdatePanel1" runat="server">
            <ContentTemplate>
            <ej:Kanban ID="Kanban" runat="server" KeyField="Status" AllowTitle="true">
                <Columns>
                    <ej:KanbanColumn HeaderText="Backlog" Key="Open" ShowAddButton="true" />
                    <ej:KanbanColumn HeaderText="In Progress" Key="InProgress" />
                    <ej:KanbanColumn HeaderText="Done" Key="Close" />
                </Columns>
                <Fields Content="Summary" PrimaryKey="Id" />
                <CustomToolBarItems>
                    <ej:KanbanCustomToolBarItems Template="#Delete" />
                </CustomToolBarItems>
                <ClientSideEvents ToolbarClick="toolbarClick" ActionComplete="kanbanComplete" />
                <EditSettings AllowAdding="true" AllowEditing="true" EditMode="Dialog">
                    <EditItems>
                        <ej:KanbanEditItem Field="Id">
                        </ej:KanbanEditItem>
                        <ej:KanbanEditItem Field="Status"></ej:KanbanEditItem>
                        <ej:KanbanEditItem Field="Assignee"></ej:KanbanEditItem>
                        <ej:KanbanEditItem Field="Estimate">
                        </ej:KanbanEditItem>
                        <ej:KanbanEditItem Field="Summary">
                        </ej:KanbanEditItem>
                    </EditItems>
                </EditSettings>
            </ej:Kanban>
                 </ContentTemplate>
        </asp:UpdatePanel>
        </div>
    </div>
    <script type="text/javascript">
        function toolbarClick(args) {
            if (args.itemName == "Delete" && this.element.find(".e-kanbancard").hasClass("e-cardselection")) {
                var selectedcard = this.element.find(".e-cardselection");
                this.KanbanEdit.deleteCard(selectedcard.attr("id"));
            }
        }
        function kanbanComplete(args) {
            //Here you can perform Kanban CRUD operations(edit, card drop, add, remove) with the help of Ajax Post Request
            var kbnUrl;
            if (!ej.isNullOrUndefined(args.action) && args.action == "add" && args.requestType == "save")
                kbnUrl = "KanbanFeatures.aspx/AddAction";
            else if (args.requestType == "drop" || (!ej.isNullOrUndefined(args.action) && args.action == "edit" && args.requestType == "save")) 
                kbnUrl = "KanbanFeatures.aspx/EditDropAction";
            else if(args.requestType == "delete")
                kbnUrl = "KanbanFeatures.aspx/removeAction"
            if (args.requestType == "delete" || args.requestType == "save" || args.requestType == "drop") {
             var card = {
                    "Id": args.data[0]["Id"],
                    "Status": args.data[0]["Status"],
                    "Assignee": args.data[0]["Assignee"],
                    "Estimate": args.data[0]["Estimate"],
                    "Summary": args.data[0]["Summary"]
            };
            $.ajax({
                async: true,
                type: "POST",
                contentType: "application/json; charset=utf-8",
                url: kbnUrl,
                data: JSON.stringify(card),
                dataType: "json",
                success: function (res) {
                },
                error: function (e) {
                }
            });
            }
        }
    </script>
    <script id="Delete" type="text/x-jsrender">
        <a class="e-customdelete  e-icon" />
    </script>
    <style>
        .e-customdelete:before {
            content: "\e800";
            line-height: 26px;
            min-height: 26px;
            min-width: 14px;
            display: inline-block;
        }

        .e-kanban .e-kanbancard .e-trainglecell {
            padding: 0px;
        }
    </style>
</asp:Content>
